//--------------------------------------Halsafars Stack----------------------------------//
//Title:            Halsafar Dynamic Managed List                                        // 
//File:             cls_Stack.h                                                          //
//Functionality:    A plain old FILO stack                                               //
//Date:             March 4, 2005 - 00:01                                                //
//Author:           Steve Damm (Halsafar)                                                //
//                                                                                       //
//Notes:            Use of this array is entitled to those who notify me prior to        //
//                  implimentation into their source.  Credit to Steve Damm must be      //
//                  included once within the users source.                               //
//---------------------------------------------------------------------------------------//
#pragma once
#ifndef __HALSSTACK
#define __HALSSTACK

#include "cls_SLAQ.h"


//The Managed List Class
template <class _TY> class STACK;       //Prototype 
template <class _TY> 
class STACK : public SLAQ<_TY>
{
private:
    void Destroy() {
        SAFE_FREE(m_Begin);
    }
public:
    STACK() {
        m_SizeOf = sizeof(_TY);
    }

    ~STACK() {
    }
};

#endif