#include <iostream>
using namespace std;

#include "../Header/cls_Timer.h"
#include "../Header/cls_Array.h"

#include <vector>
using namespace std;

int main()
{
    TimerEngine Timer;

    int i = 0;
    int iCount = 0;
    cout << "ALL TIMES ARE IN MILLISECOND (1000ms = 1s)" << endl;
    cout << "Enter how many push_backs for Hals Array and STD Vector you want: ";
    cin >> iCount;

    //--------------------------
    //RUN VECTOR BENCHMARK
    vector<int> vVector;
    cout << endl;
    cout << "SizeOf STD::Vector: " << sizeof(vVector) << endl;
    cout << "Starting Vector Assigment test..." << endl;
    Timer.SetStart();
    vVector.resize(iCount);
    for (i = 0; i < iCount; i++) {
        vVector[i] = i;
    }
    Timer.SetFinish();
    Timer.SetDelta();

    cout << "Vector time for " << iCount << " plain assigments: " << Timer.GetDelta() << endl;
    //--------------------------

    //--------------------------
    //RUN HALS ARRAY BENCHMARK
    ARRAY<int> aTemp(0);
    cout << endl;
    cout << "SizeOf Hals Array: " << sizeof(aTemp) << endl;
    cout << "Starting Halsafars Dynamic Array Assigment test..." << endl;
    Timer.SetStart();
    aTemp.Resize(iCount);
    for (i = 0; i < iCount; i++) {
        aTemp[i] = i;
    }
    Timer.SetFinish();
    Timer.SetDelta();

    cout << "Hals Array time for " << iCount << " plain assigments: " << Timer.GetDelta() << endl;
    //--------------------------




   //--------------------------
    //RUN VECTOR BENCHMARK
    vector<int> vVector2;
    cout << endl;
    cout << "SizeOf STD::Vector: " << sizeof(vVector) << endl;
    cout << "Starting Vector push_back() test (a 0 sized vector)..." << endl;
    Timer.SetStart();
    for (i = 0; i < iCount; i++) {
        vVector2.push_back(i);
    }
    Timer.SetFinish();
    Timer.SetDelta();

    cout << "Vector time for " << iCount << " push_backs: " << Timer.GetDelta() << endl;
    //--------------------------

    //--------------------------
    //RUN HALS ARRAY BENCHMARK
    ARRAY<int> bTemp(0);
    cout << endl;
    cout << "SizeOf Hals Array: " << sizeof(bTemp) << endl;
    cout << "Starting Halsafars Dynamic Array push_back() test (a 0 sized HARRAY)..." << endl;
    Timer.SetStart();
    for (i = 0; i < iCount; i++) {
        bTemp.Push(i);
    }
    Timer.SetFinish();
    Timer.SetDelta();

    cout << "Hals Array time for " << iCount << " push_backs: " << Timer.GetDelta() << endl;
    //--------------------------



    //--------------------------
    //RUN HALS MANAGED LIST BENCHMARK
    /*ManagedList<int> cList(iCount);
    cout << endl;
    cout << "SizeOf Hals Managed List: " << sizeof(cList) << endl;
    cout << "Starting Halsafars ManagedList push_back() test (a " << iCount << " sized ManagedList)..." << endl;
    cout << "List starts out sized because it depends on an initial list to be effective at all." << endl;
    Timer.SetStart();
    for (i = 0; i < iCount; i++) {
        cList.Push(i);
    }
    Timer.SetFinish();
    Timer.SetDelta();

    cout << "Hals Array time for " << iCount << " push_backs: " << Timer.GetDelta() << endl;*/
    //--------------------------

    system("PAUSE");
    return 0;
}